package main

import "time"

type AuthRequest struct {
	Client   *AuthRequestClient
	Instance string
	ID       string

	// Indicates when the request was queued for processing
	Queued time.Time
}

func (r *AuthRequest) SetId(ID string) error {
	r.ID = ID

	err := r.Client.PropagateID(ID)

	return err
}

func (r *AuthRequest) Cancel() {
	r.Client.Close()
}

func (r *AuthRequest) FulFill(t *AuthToken) error {
	return r.Client.FulFillRequest(t)
}
